Move Network definition ahead of depending definitions
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 SHELL_ENV_INIT = autotools/shell-env-init
35
36 # Note: these are automake-specific variables, and must be named after
37 # the directory + 'dir' suffix
38 clientdir = $(pkgpythondir)/client
39 hypervisordir = $(pkgpythondir)/hypervisor
40 httpdir = $(pkgpythondir)/http
41 masterddir = $(pkgpythondir)/masterd
42 confddir = $(pkgpythondir)/confd
43 rapidir = $(pkgpythondir)/rapi
44 serverdir = $(pkgpythondir)/server
45 watcherdir = $(pkgpythondir)/watcher
46 impexpddir = $(pkgpythondir)/impexpd
47 utilsdir = $(pkgpythondir)/utils
48 toolsdir = $(pkglibdir)/tools
49 iallocatorsdir = $(pkglibdir)/iallocators
50 pytoolsdir = $(pkgpythondir)/tools
51 docdir = $(datadir)/doc/$(PACKAGE)
52 myexeclibdir = $(pkglibdir)
53
54 # Delete output file if an error occurred while building it
55 .DELETE_ON_ERROR:
56
57 HTOOLS_DIRS = \
58         htools \
59         htools/Ganeti \
60         htools/Ganeti/Block \
61         htools/Ganeti/Block/Drbd \
62         htools/Ganeti/Confd \
63         htools/Ganeti/DataCollectors \
64         htools/Ganeti/HTools \
65         htools/Ganeti/HTools/Backend \
66         htools/Ganeti/HTools/Program \
67         htools/Ganeti/Query \
68         htest \
69         htest/Test \
70         htest/Test/Ganeti \
71         htest/Test/Ganeti/Block \
72         htest/Test/Ganeti/Block/Drbd \
73         htest/Test/Ganeti/Confd \
74         htest/Test/Ganeti/HTools \
75         htest/Test/Ganeti/HTools/Backend \
76         htest/Test/Ganeti/Query
77
78 DIRS = \
79         $(HTOOLS_DIRS) \
80         autotools \
81         daemons \
82         devel \
83         doc \
84         doc/examples \
85         doc/examples/gnt-debug \
86         doc/examples/hooks \
87         htest/data \
88         htest/data/rapi \
89         htest/shelltests \
90         lib \
91         lib/build \
92         lib/client \
93         lib/confd \
94         lib/http \
95         lib/hypervisor \
96         lib/impexpd \
97         lib/masterd \
98         lib/rapi \
99         lib/server \
100         lib/tools \
101         lib/utils \
102         lib/watcher \
103         man \
104         qa \
105         test \
106         test/data \
107         test/data/ovfdata \
108         test/data/ovfdata/other \
109         tools
110
111 ALL_APIDOC_HS_DIRS = \
112         $(APIDOC_HS_DIR) \
113         $(APIDOC_HS_DIR)/Ganeti \
114         $(APIDOC_HS_DIR)/Ganeti/Block \
115         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
116         $(APIDOC_HS_DIR)/Ganeti/Confd \
117         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
118         $(APIDOC_HS_DIR)/Ganeti/HTools \
119         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
120         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
121         $(APIDOC_HS_DIR)/Ganeti/Query
122
123 BUILDTIME_DIR_AUTOCREATE = \
124         scripts \
125         $(APIDOC_DIR) \
126         $(ALL_APIDOC_HS_DIRS) \
127         $(APIDOC_PY_DIR) \
128         $(COVERAGE_DIR) \
129         $(COVERAGE_HS_DIR) \
130         $(COVERAGE_PY_DIR) \
131         .hpc
132
133 BUILDTIME_DIRS = \
134         $(BUILDTIME_DIR_AUTOCREATE) \
135         doc/html
136
137 DIRCHECK_EXCLUDE = \
138         $(BUILDTIME_DIRS) \
139         ganeti-[0-9]*.[0-9]*.[0-9]* \
140         doc/html/_* \
141         autom4te.cache
142
143 # some helper vars
144 COVERAGE_DIR = doc/coverage
145 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
146 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
147 APIDOC_DIR = doc/api
148 APIDOC_PY_DIR = $(APIDOC_DIR)/py
149 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
150
151 MAINTAINERCLEANFILES = \
152         $(docpng) \
153         $(maninput) \
154         doc/install-quick.rst \
155         doc/news.rst \
156         doc/upgrade.rst \
157         vcs-version
158
159 maintainer-clean-local:
160         rm -rf $(BUILDTIME_DIRS)
161
162 CLEANFILES = \
163         $(addsuffix /*.py[co],$(DIRS)) \
164         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
165         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
166         $(PYTHON_BOOTSTRAP) \
167         epydoc.conf \
168         $(REPLACE_VARS_SED) \
169         $(SHELL_ENV_INIT) \
170         daemons/daemon-util \
171         daemons/ganeti-cleaner \
172         $(BUILT_EXAMPLES) \
173         doc/examples/bash_completion \
174         doc/examples/bash_completion-debug \
175         lib/_generated_rpc.py \
176         $(man_MANS) \
177         $(manhtml) \
178         tools/kvm-ifup \
179         tools/vcluster-setup \
180         stamp-directories \
181         stamp-srclinks \
182         $(nodist_pkgpython_PYTHON) \
183         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
184         $(HS_BUILT_TEST_HELPERS) \
185         htools/ganeti-confd \
186         .hpc/*.mix htools/*.tix htest/*.tix \
187         doc/hs-lint.html
188
189 GENERATED_FILES = \
190         $(built_base_sources) \
191         $(BUILT_PYTHON_SOURCES) \
192         $(PYTHON_BOOTSTRAP)
193
194 HTOOLS_GENERATED_FILES =
195 if WANT_HTOOLS
196 HTOOLS_GENERATED_FILES += $(HS_PROGS)
197 if ENABLE_CONFD
198 HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
199 endif
200 endif
201
202 built_base_sources = \
203         stamp-directories \
204         stamp-srclinks
205
206 built_python_base_sources = \
207         lib/_autoconf.py \
208         lib/_vcsversion.py
209
210 BUILT_PYTHON_SOURCES = \
211         $(built_python_base_sources) \
212         lib/_generated_rpc.py
213
214 # Generating the RPC wrappers depends on many things, so make sure
215 # it's built at the end of the built sources
216 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
217
218 # these are all built from the underlying %.in sources
219 BUILT_EXAMPLES = \
220         doc/examples/ganeti-kvm-poweroff.initd \
221         doc/examples/ganeti.cron \
222         doc/examples/ganeti.initd \
223         doc/examples/ganeti-master-role.ocf \
224         doc/examples/ganeti-node-role.ocf \
225         doc/examples/gnt-config-backup \
226         doc/examples/hooks/ipsec
227
228 nodist_pkgpython_PYTHON = \
229         $(BUILT_PYTHON_SOURCES)
230
231 noinst_PYTHON = \
232         lib/build/__init__.py \
233         lib/build/shell_example_lexer.py \
234         lib/build/sphinx_ext.py
235
236 pkgpython_PYTHON = \
237         lib/__init__.py \
238         lib/asyncnotifier.py \
239         lib/backend.py \
240         lib/bdev.py \
241         lib/bootstrap.py \
242         lib/cli.py \
243         lib/cmdlib.py \
244         lib/compat.py \
245         lib/config.py \
246         lib/constants.py \
247         lib/daemon.py \
248         lib/errors.py \
249         lib/ht.py \
250         lib/jqueue.py \
251         lib/jstore.py \
252         lib/locking.py \
253         lib/luxi.py \
254         lib/mcpu.py \
255         lib/netutils.py \
256         lib/objects.py \
257         lib/objectutils.py \
258         lib/opcodes.py \
259         lib/ovf.py \
260         lib/pathutils.py \
261         lib/qlang.py \
262         lib/query.py \
263         lib/rpc.py \
264         lib/rpc_defs.py \
265         lib/runtime.py \
266         lib/serializer.py \
267         lib/ssconf.py \
268         lib/ssh.py \
269         lib/storage.py \
270         lib/uidpool.py \
271         lib/vcluster.py \
272         lib/network.py \
273         lib/workerpool.py
274
275 client_PYTHON = \
276         lib/client/__init__.py \
277         lib/client/gnt_backup.py \
278         lib/client/gnt_cluster.py \
279         lib/client/gnt_debug.py \
280         lib/client/gnt_group.py \
281         lib/client/gnt_instance.py \
282         lib/client/gnt_job.py \
283         lib/client/gnt_node.py \
284         lib/client/gnt_network.py \
285         lib/client/gnt_os.py
286
287 hypervisor_PYTHON = \
288         lib/hypervisor/__init__.py \
289         lib/hypervisor/hv_base.py \
290         lib/hypervisor/hv_chroot.py \
291         lib/hypervisor/hv_fake.py \
292         lib/hypervisor/hv_kvm.py \
293         lib/hypervisor/hv_lxc.py \
294         lib/hypervisor/hv_xen.py
295
296 rapi_PYTHON = \
297         lib/rapi/__init__.py \
298         lib/rapi/baserlib.py \
299         lib/rapi/client.py \
300         lib/rapi/client_utils.py \
301         lib/rapi/connector.py \
302         lib/rapi/rlib2.py \
303         lib/rapi/testutils.py
304
305 http_PYTHON = \
306         lib/http/__init__.py \
307         lib/http/auth.py \
308         lib/http/client.py \
309         lib/http/server.py
310
311 confd_PYTHON = \
312         lib/confd/__init__.py \
313         lib/confd/client.py
314
315 masterd_PYTHON = \
316         lib/masterd/__init__.py \
317         lib/masterd/iallocator.py \
318         lib/masterd/instance.py
319
320 impexpd_PYTHON = \
321         lib/impexpd/__init__.py
322
323 watcher_PYTHON = \
324         lib/watcher/__init__.py \
325         lib/watcher/nodemaint.py \
326         lib/watcher/state.py
327
328 server_PYTHON = \
329         lib/server/__init__.py \
330         lib/server/masterd.py \
331         lib/server/noded.py \
332         lib/server/rapi.py
333
334 pytools_PYTHON = \
335         lib/tools/__init__.py \
336         lib/tools/ensure_dirs.py \
337         lib/tools/node_cleanup.py \
338         lib/tools/node_daemon_setup.py \
339         lib/tools/prepare_node_join.py
340
341 utils_PYTHON = \
342         lib/utils/__init__.py \
343         lib/utils/algo.py \
344         lib/utils/filelock.py \
345         lib/utils/hash.py \
346         lib/utils/io.py \
347         lib/utils/log.py \
348         lib/utils/mlock.py \
349         lib/utils/nodesetup.py \
350         lib/utils/process.py \
351         lib/utils/retry.py \
352         lib/utils/text.py \
353         lib/utils/wrapper.py \
354         lib/utils/x509.py
355
356 docrst = \
357         doc/admin.rst \
358         doc/cluster-merge.rst \
359         doc/design-2.0.rst \
360         doc/design-2.1.rst \
361         doc/design-2.2.rst \
362         doc/design-2.3.rst \
363         doc/design-2.4.rst \
364         doc/design-2.5.rst \
365         doc/design-2.6.rst \
366         doc/design-2.7.rst \
367         doc/design-autorepair.rst \
368         doc/design-bulk-create.rst \
369         doc/design-chained-jobs.rst \
370         doc/design-cpu-pinning.rst \
371         doc/design-draft.rst \
372         doc/design-htools-2.3.rst \
373         doc/design-http-server.rst \
374         doc/design-impexp2.rst \
375         doc/design-lu-generated-jobs.rst \
376         doc/design-linuxha.rst \
377         doc/design-multi-reloc.rst \
378         doc/design-network.rst \
379         doc/design-node-add.rst \
380         doc/design-oob.rst \
381         doc/design-ovf-support.rst \
382         doc/design-opportunistic-locking.rst \
383         doc/design-partitioned.rst \
384         doc/design-query-splitting.rst \
385         doc/design-query2.rst \
386         doc/design-remote-commands.rst \
387         doc/design-resource-model.rst \
388         doc/design-shared-storage.rst \
389         doc/design-monitoring-agent.rst \
390         doc/design-virtual-clusters.rst \
391         doc/design-x509-ca.rst \
392         doc/devnotes.rst \
393         doc/glossary.rst \
394         doc/hooks.rst \
395         doc/iallocator.rst \
396         doc/index.rst \
397         doc/install-quick.rst \
398         doc/install.rst \
399         doc/locking.rst \
400         doc/move-instance.rst \
401         doc/news.rst \
402         doc/ovfconverter.rst \
403         doc/rapi.rst \
404         doc/security.rst \
405         doc/upgrade.rst \
406         doc/virtual-cluster.rst \
407         doc/walkthrough.rst
408
409 HS_PROGS = htools/htools htools/mon-collector
410 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
411 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
412
413 HS_ALL_PROGS = \
414         $(HS_PROGS) \
415         htest/hpc-htools \
416         htest/hpc-mon-collector \
417         htest/test \
418         htools/hconfd \
419         htools/rpc-test
420
421 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
422 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
423
424 HFLAGS = \
425         -O -Wall -Werror -ihtools \
426         -fwarn-monomorphism-restriction \
427         -fwarn-tabs \
428         $(GHC_BYVERSION_FLAGS)
429
430 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
431 HEXTRA =
432 # internal extra flags (used for htest/test mainly)
433 HEXTRA_INT =
434 # exclude options for coverage reports
435 HPCEXCL = --exclude Main \
436         --exclude Ganeti.Constants \
437         --exclude Ganeti.HTools.QC \
438         --exclude Ganeti.THH \
439         --exclude Ganeti.Version \
440         --exclude Test.Ganeti.Attoparsec \
441         --exclude Test.Ganeti.TestCommon \
442         --exclude Test.Ganeti.TestHTools \
443         --exclude Test.Ganeti.TestHelper \
444         --exclude Test.Ganeti.TestImports \
445         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
446
447 HS_LIB_SRCS = \
448         htools/Ganeti/Block/Drbd/Types.hs \
449         htools/Ganeti/Block/Drbd/Parser.hs \
450         htools/Ganeti/BasicTypes.hs \
451         htools/Ganeti/Common.hs \
452         htools/Ganeti/Compat.hs \
453         htools/Ganeti/Confd/Server.hs \
454         htools/Ganeti/Confd/Types.hs \
455         htools/Ganeti/Confd/Utils.hs \
456         htools/Ganeti/Config.hs \
457         htools/Ganeti/Daemon.hs \
458         htools/Ganeti/DataCollectors/CLI.hs \
459         htools/Ganeti/DataCollectors/Drbd.hs \
460         htools/Ganeti/DataCollectors/Program.hs \
461         htools/Ganeti/Errors.hs \
462         htools/Ganeti/HTools/Backend/IAlloc.hs \
463         htools/Ganeti/HTools/Backend/Luxi.hs \
464         htools/Ganeti/HTools/Backend/Rapi.hs \
465         htools/Ganeti/HTools/Backend/Simu.hs \
466         htools/Ganeti/HTools/Backend/Text.hs \
467         htools/Ganeti/HTools/CLI.hs \
468         htools/Ganeti/HTools/Cluster.hs \
469         htools/Ganeti/HTools/Container.hs \
470         htools/Ganeti/HTools/ExtLoader.hs \
471         htools/Ganeti/HTools/Graph.hs \
472         htools/Ganeti/HTools/Group.hs \
473         htools/Ganeti/HTools/Instance.hs \
474         htools/Ganeti/HTools/Loader.hs \
475         htools/Ganeti/HTools/Node.hs \
476         htools/Ganeti/HTools/PeerMap.hs \
477         htools/Ganeti/HTools/Program.hs \
478         htools/Ganeti/HTools/Program/Hail.hs \
479         htools/Ganeti/HTools/Program/Hbal.hs \
480         htools/Ganeti/HTools/Program/Hcheck.hs \
481         htools/Ganeti/HTools/Program/Hinfo.hs \
482         htools/Ganeti/HTools/Program/Hscan.hs \
483         htools/Ganeti/HTools/Program/Hspace.hs \
484         htools/Ganeti/HTools/Types.hs \
485         htools/Ganeti/Hash.hs \
486         htools/Ganeti/JQueue.hs \
487         htools/Ganeti/JSON.hs \
488         htools/Ganeti/Jobs.hs \
489         htools/Ganeti/Logging.hs \
490         htools/Ganeti/Luxi.hs \
491         htools/Ganeti/Network.hs \
492         htools/Ganeti/Objects.hs \
493         htools/Ganeti/OpCodes.hs \
494         htools/Ganeti/OpParams.hs \
495         htools/Ganeti/Path.hs \
496         htools/Ganeti/Query/Common.hs \
497         htools/Ganeti/Query/Filter.hs \
498         htools/Ganeti/Query/Group.hs \
499         htools/Ganeti/Query/Job.hs \
500         htools/Ganeti/Query/Language.hs \
501         htools/Ganeti/Query/Node.hs \
502         htools/Ganeti/Query/Query.hs \
503         htools/Ganeti/Query/Server.hs \
504         htools/Ganeti/Query/Types.hs \
505         htools/Ganeti/Rpc.hs \
506         htools/Ganeti/Runtime.hs \
507         htools/Ganeti/Ssconf.hs \
508         htools/Ganeti/THH.hs \
509         htools/Ganeti/Types.hs \
510         htools/Ganeti/Utils.hs
511
512 HS_TEST_SRCS = \
513         htest/Test/Ganeti/Attoparsec.hs \
514         htest/Test/Ganeti/BasicTypes.hs \
515         htest/Test/Ganeti/Block/Drbd/Parser.hs \
516         htest/Test/Ganeti/Block/Drbd/Types.hs \
517         htest/Test/Ganeti/Common.hs \
518         htest/Test/Ganeti/Confd/Types.hs \
519         htest/Test/Ganeti/Confd/Utils.hs \
520         htest/Test/Ganeti/Daemon.hs \
521         htest/Test/Ganeti/Errors.hs \
522         htest/Test/Ganeti/HTools/Backend/Simu.hs \
523         htest/Test/Ganeti/HTools/Backend/Text.hs \
524         htest/Test/Ganeti/HTools/CLI.hs \
525         htest/Test/Ganeti/HTools/Cluster.hs \
526         htest/Test/Ganeti/HTools/Container.hs \
527         htest/Test/Ganeti/HTools/Graph.hs \
528         htest/Test/Ganeti/HTools/Instance.hs \
529         htest/Test/Ganeti/HTools/Loader.hs \
530         htest/Test/Ganeti/HTools/Node.hs \
531         htest/Test/Ganeti/HTools/PeerMap.hs \
532         htest/Test/Ganeti/HTools/Types.hs \
533         htest/Test/Ganeti/JSON.hs \
534         htest/Test/Ganeti/Jobs.hs \
535         htest/Test/Ganeti/JQueue.hs \
536         htest/Test/Ganeti/Luxi.hs \
537         htest/Test/Ganeti/Network.hs \
538         htest/Test/Ganeti/Objects.hs \
539         htest/Test/Ganeti/OpCodes.hs \
540         htest/Test/Ganeti/Query/Filter.hs \
541         htest/Test/Ganeti/Query/Language.hs \
542         htest/Test/Ganeti/Query/Query.hs \
543         htest/Test/Ganeti/Rpc.hs \
544         htest/Test/Ganeti/Ssconf.hs \
545         htest/Test/Ganeti/THH.hs \
546         htest/Test/Ganeti/TestCommon.hs \
547         htest/Test/Ganeti/TestHTools.hs \
548         htest/Test/Ganeti/TestHelper.hs \
549         htest/Test/Ganeti/Types.hs \
550         htest/Test/Ganeti/Utils.hs
551
552 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
553
554 HS_BUILT_SRCS = \
555         htest/Test/Ganeti/TestImports.hs \
556         htools/Ganeti/Constants.hs \
557         htools/Ganeti/Version.hs
558 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
559
560 $(RUN_IN_TEMPDIR): | stamp-directories
561
562 # Note: we use here an order-only prerequisite, as the contents of
563 # _autoconf.py are not actually influencing the html build output: it
564 # has to exist in order for the sphinx module to be loaded
565 # successfully, but we certainly don't want the docs to be rebuilt if
566 # it changes
567 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
568         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
569         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
570         | $(BUILT_PYTHON_SOURCES)
571         @test -n "$(SPHINX)" || \
572             { echo 'sphinx-build' not found during configure; exit 1; }
573         @mkdir_p@ $(dir $@)
574         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
575             -d . \
576             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
577             -D release="$(PACKAGE_VERSION)" \
578             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
579         rm -f doc/html/.buildinfo doc/html/objects.inv
580         touch $@
581
582 doc/html: doc/html/index.html
583
584 doc/install-quick.rst: INSTALL
585 doc/news.rst: NEWS
586 doc/upgrade.rst: UPGRADE
587
588 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
589         set -e; \
590         { echo '.. This file is automatically updated at build time from $<.'; \
591           echo '.. Do not edit.'; \
592           echo; \
593           cat $<; \
594         } > $@
595
596 docdot = \
597         doc/arch-2.0.dot \
598         doc/design-2.1-lock-acquire.dot \
599         doc/design-2.1-lock-release.dot
600
601 docpng = $(patsubst %.dot,%.png,$(docdot))
602
603 # Things to build but not to install (add it to EXTRA_DIST if it should be
604 # distributed)
605 noinst_DATA = \
606         doc/html \
607         $(BUILT_EXAMPLES) \
608         doc/examples/bash_completion \
609         doc/examples/bash_completion-debug \
610         $(manhtml)
611
612 gnt_scripts = \
613         scripts/gnt-backup \
614         scripts/gnt-cluster \
615         scripts/gnt-debug \
616         scripts/gnt-group \
617         scripts/gnt-instance \
618         scripts/gnt-job \
619         scripts/gnt-network \
620         scripts/gnt-node \
621         scripts/gnt-os
622
623 PYTHON_BOOTSTRAP_SBIN = \
624         daemons/ganeti-masterd \
625         daemons/ganeti-noded \
626         daemons/ganeti-rapi \
627         daemons/ganeti-watcher \
628         $(gnt_scripts)
629
630 PYTHON_BOOTSTRAP = \
631         $(PYTHON_BOOTSTRAP_SBIN) \
632         tools/ensure-dirs \
633         tools/node-cleanup \
634         tools/node-daemon-setup \
635         tools/prepare-node-join
636
637 qa_scripts = \
638         qa/__init__.py \
639         qa/ganeti-qa.py \
640         qa/qa_cluster.py \
641         qa/qa_config.py \
642         qa/qa_daemon.py \
643         qa/qa_env.py \
644         qa/qa_error.py \
645         qa/qa_group.py \
646         qa/qa_instance.py \
647         qa/qa_job.py \
648         qa/qa_node.py \
649         qa/qa_os.py \
650         qa/qa_rapi.py \
651         qa/qa_tags.py \
652         qa/qa_utils.py
653
654 bin_SCRIPTS =
655 if WANT_HTOOLS
656 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
657 install-exec-hook:
658         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
659 # FIXME: this is a hardcoded logic, instead of auto-resolving
660         $(LN_S) -f ../../../bin/htools \
661           $(DESTDIR)$(iallocatorsdir)/hail
662         for role in $(HS_BIN_ROLES); do \
663           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
664         done
665 endif
666
667 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
668         @if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
669           echo "Error: cannot run unittests without the development" \
670                " libraries (see devnotes.rst)" 1>&2; \
671           exit 1; \
672         fi
673         @rm -f $(notdir $@).tix
674         $(GHC) --make \
675           $(HFLAGS) \
676           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
677           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
678           $(HEXTRA) $(HEXTRA_INT) $@
679         @touch "$@"
680
681 # for the htest/test binary, we need to enable profiling/coverage
682 htest/test: HEXTRA_INT=-fhpc -ihtest
683
684 # we compile the hpc-htools binary with the program coverage
685 htest/hpc-htools: HEXTRA_INT=-fhpc
686
687 # we compile the hpc-mon-collector binary with the program coverage
688 htest/hpc-mon-collector: HEXTRA_INT=-fhpc
689
690 # test dependency
691 htest/offline-tests.sh: htest/hpc-htools htest/hpc-mon-collector
692
693 # rules for building profiling-enabled versions of the haskell
694 # programs: hs-prof does the full two-step build, whereas
695 # hs-prof-quick does only the final rebuild (hs-prof must have been
696 # run before)
697 .PHONY: hs-prof hs-prof-quick
698 hs-prof:
699         @if [ -z "$(TARGET)" ]; then \
700           echo "You need to define TARGET when running this rule" 1>&2; \
701           exit 1; \
702         fi
703         $(MAKE) $(AM_MAKEFLAGS) clean
704         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
705         rm -f $(HS_ALL_PROGS)
706         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
707
708 hs-prof-quick:
709         @if [ -z "$(TARGET)" ]; then \
710           echo "You need to define TARGET when running this rule" 1>&2; \
711           exit 1; \
712         fi
713         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
714
715 dist_sbin_SCRIPTS = \
716         tools/ganeti-listrunner
717
718 nodist_sbin_SCRIPTS = \
719         $(PYTHON_BOOTSTRAP_SBIN) \
720         daemons/ganeti-cleaner
721
722 if ENABLE_CONFD
723 htools/ganeti-confd: htools/hconfd
724         cp -f $< $@
725
726 nodist_sbin_SCRIPTS += htools/ganeti-confd
727 endif
728
729 python_scripts = \
730         tools/burnin \
731         tools/cfgshell \
732         tools/cfgupgrade \
733         tools/cfgupgrade12 \
734         tools/cluster-merge \
735         tools/confd-client \
736         tools/fmtjson \
737         tools/lvmstrap \
738         tools/move-instance \
739         tools/ovfconverter \
740         tools/sanitize-config
741
742 dist_tools_SCRIPTS = \
743         $(python_scripts) \
744         tools/kvm-console-wrapper \
745         tools/master-ip-setup \
746         tools/xen-console-wrapper
747
748 nodist_tools_python_scripts = \
749         tools/node-cleanup
750
751 nodist_tools_SCRIPTS = \
752         $(nodist_tools_python_scripts) \
753         tools/vcluster-setup
754
755 pkglib_python_scripts = \
756         daemons/import-export \
757         tools/check-cert-expired
758
759 nodist_pkglib_python_scripts = \
760         tools/ensure-dirs \
761         tools/node-daemon-setup \
762         tools/prepare-node-join
763
764 myexeclib_SCRIPTS = \
765         daemons/daemon-util \
766         tools/kvm-ifup \
767         $(pkglib_python_scripts) \
768         htools/mon-collector
769
770 nodist_myexeclib_SCRIPTS = \
771         $(nodist_pkglib_python_scripts)
772
773 EXTRA_DIST = \
774         NEWS \
775         UPGRADE \
776         epydoc.conf.in \
777         pylintrc \
778         autotools/build-bash-completion \
779         autotools/build-rpc \
780         autotools/check-header \
781         autotools/check-imports \
782         autotools/check-man-dashes \
783         autotools/check-man-warnings \
784         autotools/check-news \
785         autotools/check-python-code \
786         autotools/check-tar \
787         autotools/check-version \
788         autotools/convert-constants \
789         autotools/docpp \
790         autotools/gen-coverage \
791         autotools/testrunner \
792         autotools/wrong-hardcoded-paths \
793         $(RUN_IN_TEMPDIR) \
794         daemons/daemon-util.in \
795         daemons/ganeti-cleaner.in \
796         $(pkglib_python_scripts) \
797         devel/upload \
798         tools/kvm-ifup.in \
799         tools/vcluster-setup.in \
800         $(docdot) \
801         $(docpng) \
802         $(docrst) \
803         doc/conf.py \
804         doc/html \
805         $(BUILT_EXAMPLES:%=%.in) \
806         doc/examples/ganeti.default \
807         doc/examples/ganeti.default-debug \
808         doc/examples/hooks/ethers \
809         doc/examples/gnt-debug/README \
810         doc/examples/gnt-debug/delay0.json \
811         doc/examples/gnt-debug/delay50.json \
812         test/lockperf.py \
813         test/testutils.py \
814         test/mocks.py \
815         $(dist_TESTS) \
816         $(TEST_FILES) \
817         man/footer.rst \
818         $(manrst) \
819         $(maninput) \
820         qa/qa-sample.json \
821         $(qa_scripts) \
822         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
823         $(HS_PROG_SRCS) \
824         htools/lint-hints.hs \
825         htest/cli-tests-defs.sh \
826         htest/offline-test.sh \
827         .ghci
828
829 man_MANS = \
830         man/ganeti-cleaner.8 \
831         man/ganeti-confd.8 \
832         man/ganeti-listrunner.8 \
833         man/ganeti-masterd.8 \
834         man/ganeti-noded.8 \
835         man/ganeti-os-interface.7 \
836         man/ganeti-rapi.8 \
837         man/ganeti-watcher.8 \
838         man/ganeti.7 \
839         man/gnt-backup.8 \
840         man/gnt-cluster.8 \
841         man/gnt-debug.8 \
842         man/gnt-group.8 \
843         man/gnt-network.8 \
844         man/gnt-instance.8 \
845         man/gnt-job.8 \
846         man/gnt-node.8 \
847         man/gnt-os.8 \
848         man/hail.1 \
849         man/hbal.1 \
850         man/hcheck.1 \
851         man/hinfo.1 \
852         man/hscan.1 \
853         man/hspace.1 \
854         man/htools.1 \
855         man/mon-collector.7
856
857 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
858 manhtml = $(patsubst %.rst,%.html,$(manrst))
859 mangen = $(patsubst %.rst,%.gen,$(manrst))
860 maninput = \
861         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
862         $(patsubst %.html,%.html.in,$(manhtml)) \
863         man/footer.man man/footer.html $(mangen)
864
865 TEST_FILES = \
866         htest/data/common-suffix.data \
867         htest/data/hail-alloc-drbd.json \
868         htest/data/hail-change-group.json \
869         htest/data/hail-invalid-reloc.json \
870         htest/data/hail-node-evac.json \
871         htest/data/hail-reloc-drbd.json \
872         htest/data/hbal-excl-tags.data \
873         htest/data/hbal-split-insts.data \
874         htest/data/invalid-node.data \
875         htest/data/missing-resources.data \
876         htest/data/rapi/groups.json \
877         htest/data/rapi/info.json \
878         htest/data/rapi/instances.json \
879         htest/data/rapi/nodes.json \
880         htest/shelltests/htools-balancing.test \
881         htest/shelltests/htools-basic.test \
882         htest/shelltests/htools-dynutil.test \
883         htest/shelltests/htools-excl.test \
884         htest/shelltests/htools-hail.test \
885         htest/shelltests/htools-hspace.test \
886         htest/shelltests/htools-invalid.test \
887         htest/shelltests/htools-multi-group.test \
888         htest/shelltests/htools-no-backend.test \
889         htest/shelltests/htools-rapi.test \
890         htest/shelltests/htools-single-group.test \
891         htest/shelltests/htools-text-backend.test \
892         htest/shelltests/htools-mon-collector.test \
893         test/data/bdev-drbd-8.0.txt \
894         test/data/bdev-drbd-8.3.txt \
895         test/data/bdev-drbd-disk.txt \
896         test/data/bdev-drbd-net-ip4.txt \
897         test/data/bdev-drbd-net-ip6.txt \
898         test/data/cert1.pem \
899         test/data/cert2.pem \
900         test/data/ip-addr-show-dummy0.txt \
901         test/data/ip-addr-show-lo-ipv4.txt \
902         test/data/ip-addr-show-lo-ipv6.txt \
903         test/data/ip-addr-show-lo-oneline-ipv4.txt \
904         test/data/ip-addr-show-lo-oneline-ipv6.txt \
905         test/data/ip-addr-show-lo-oneline.txt \
906         test/data/ip-addr-show-lo.txt \
907         test/data/kvm_0.12.5_help.txt \
908         test/data/kvm_0.15.90_help.txt \
909         test/data/kvm_0.9.1_help.txt \
910         test/data/kvm_1.0_help.txt \
911         test/data/ovfdata/compr_disk.vmdk.gz \
912         test/data/ovfdata/config.ini \
913         test/data/ovfdata/corrupted_resources.ovf \
914         test/data/ovfdata/empty.ini \
915         test/data/ovfdata/empty.ovf \
916         test/data/ovfdata/ganeti.mf \
917         test/data/ovfdata/ganeti.ovf \
918         test/data/ovfdata/gzip_disk.ovf \
919         test/data/ovfdata/new_disk.vmdk \
920         test/data/ovfdata/no_disk.ini \
921         test/data/ovfdata/no_disk_in_ref.ovf \
922         test/data/ovfdata/no_os.ini \
923         test/data/ovfdata/no_ovf.ova \
924         test/data/ovfdata/other/rawdisk.raw \
925         test/data/ovfdata/ova.ova \
926         test/data/ovfdata/rawdisk.raw \
927         test/data/ovfdata/second_disk.vmdk \
928         test/data/ovfdata/unsafe_path.ini \
929         test/data/ovfdata/virtualbox.ovf \
930         test/data/ovfdata/wrong_config.ini \
931         test/data/ovfdata/wrong_extension.ovd \
932         test/data/ovfdata/wrong_manifest.mf \
933         test/data/ovfdata/wrong_manifest.ovf \
934         test/data/ovfdata/wrong_ova.ova \
935         test/data/ovfdata/wrong_xml.ovf \
936         test/data/proc_drbd8.txt \
937         test/data/proc_drbd80-emptyline.txt \
938         test/data/proc_drbd83.txt \
939         test/data/proc_drbd83_sync.txt \
940         test/data/proc_drbd83_sync_want.txt \
941         test/data/proc_drbd83_sync_krnl2.6.39.txt \
942         test/data/sys_drbd_usermode_helper.txt \
943         test/data/vgreduce-removemissing-2.02.02.txt \
944         test/data/vgreduce-removemissing-2.02.66-fail.txt \
945         test/data/vgreduce-removemissing-2.02.66-ok.txt \
946         test/data/vgs-missing-pvs-2.02.02.txt \
947         test/data/vgs-missing-pvs-2.02.66.txt \
948         test/ganeti-cli.test \
949         test/gnt-cli.test \
950         test/import-export_unittest-helper
951
952 python_tests = \
953         doc/examples/rapi_testutils.py \
954         test/cfgupgrade_unittest.py \
955         test/docs_unittest.py \
956         test/ganeti.asyncnotifier_unittest.py \
957         test/ganeti.backend_unittest-runasroot.py \
958         test/ganeti.backend_unittest.py \
959         test/ganeti.bdev_unittest.py \
960         test/ganeti.cli_unittest.py \
961         test/ganeti.client.gnt_cluster_unittest.py \
962         test/ganeti.client.gnt_instance_unittest.py \
963         test/ganeti.client.gnt_job_unittest.py \
964         test/ganeti.cmdlib_unittest.py \
965         test/ganeti.compat_unittest.py \
966         test/ganeti.confd.client_unittest.py \
967         test/ganeti.config_unittest.py \
968         test/ganeti.constants_unittest.py \
969         test/ganeti.daemon_unittest.py \
970         test/ganeti.errors_unittest.py \
971         test/ganeti.hooks_unittest.py \
972         test/ganeti.ht_unittest.py \
973         test/ganeti.http_unittest.py \
974         test/ganeti.hypervisor.hv_chroot_unittest.py \
975         test/ganeti.hypervisor.hv_fake_unittest.py \
976         test/ganeti.hypervisor.hv_kvm_unittest.py \
977         test/ganeti.hypervisor.hv_lxc_unittest.py \
978         test/ganeti.hypervisor.hv_xen_unittest.py \
979         test/ganeti.hypervisor_unittest.py \
980         test/ganeti.impexpd_unittest.py \
981         test/ganeti.jqueue_unittest.py \
982         test/ganeti.jstore_unittest.py \
983         test/ganeti.locking_unittest.py \
984         test/ganeti.luxi_unittest.py \
985         test/ganeti.masterd.iallocator_unittest.py \
986         test/ganeti.masterd.instance_unittest.py \
987         test/ganeti.mcpu_unittest.py \
988         test/ganeti.netutils_unittest.py \
989         test/ganeti.objects_unittest.py \
990         test/ganeti.objectutils_unittest.py \
991         test/ganeti.opcodes_unittest.py \
992         test/ganeti.ovf_unittest.py \
993         test/ganeti.qlang_unittest.py \
994         test/ganeti.query_unittest.py \
995         test/ganeti.rapi.baserlib_unittest.py \
996         test/ganeti.rapi.client_unittest.py \
997         test/ganeti.rapi.resources_unittest.py \
998         test/ganeti.rapi.rlib2_unittest.py \
999         test/ganeti.rapi.testutils_unittest.py \
1000         test/ganeti.rpc_unittest.py \
1001         test/ganeti.runtime_unittest.py \
1002         test/ganeti.serializer_unittest.py \
1003         test/ganeti.server.rapi_unittest.py \
1004         test/ganeti.ssconf_unittest.py \
1005         test/ganeti.ssh_unittest.py \
1006         test/ganeti.storage_unittest.py \
1007         test/ganeti.tools.ensure_dirs_unittest.py \
1008         test/ganeti.tools.node_daemon_setup_unittest.py \
1009         test/ganeti.tools.prepare_node_join_unittest.py \
1010         test/ganeti.uidpool_unittest.py \
1011         test/ganeti.utils.algo_unittest.py \
1012         test/ganeti.utils.filelock_unittest.py \
1013         test/ganeti.utils.hash_unittest.py \
1014         test/ganeti.utils.io_unittest-runasroot.py \
1015         test/ganeti.utils.io_unittest.py \
1016         test/ganeti.utils.log_unittest.py \
1017         test/ganeti.utils.mlock_unittest.py \
1018         test/ganeti.utils.nodesetup_unittest.py \
1019         test/ganeti.utils.process_unittest.py \
1020         test/ganeti.utils.retry_unittest.py \
1021         test/ganeti.utils.text_unittest.py \
1022         test/ganeti.utils.wrapper_unittest.py \
1023         test/ganeti.utils.x509_unittest.py \
1024         test/ganeti.utils_unittest.py \
1025         test/ganeti.vcluster_unittest.py \
1026         test/ganeti.workerpool_unittest.py \
1027         test/pycurl_reset_unittest.py \
1028         test/qa.qa_config_unittest.py \
1029         test/tempfile_fork_unittest.py
1030
1031 haskell_tests = htest/test
1032
1033 dist_TESTS = \
1034         test/check-cert-expired_unittest.bash \
1035         test/daemon-util_unittest.bash \
1036         test/ganeti-cleaner_unittest.bash \
1037         test/import-export_unittest.bash \
1038         test/cli-test.bash \
1039         test/bash_completion.bash \
1040         $(python_tests)
1041
1042 nodist_TESTS =
1043 check_SCRIPTS =
1044
1045 if WANT_HTOOLSTESTS
1046 nodist_TESTS += $(haskell_tests)
1047 dist_TESTS += htest/offline-test.sh
1048 check_SCRIPTS += \
1049         htest/hpc-htools \
1050         htest/hpc-mon-collector \
1051         $(HS_BUILT_TEST_HELPERS)
1052 endif
1053
1054 TESTS = $(dist_TESTS) $(nodist_TESTS)
1055
1056 # Environment for all tests
1057 PLAIN_TESTS_ENVIRONMENT = \
1058         PYTHONPATH=. \
1059         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1060         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1061         $(RUN_IN_TEMPDIR)
1062
1063 # Environment for tests run by automake
1064 TESTS_ENVIRONMENT = \
1065         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1066
1067 all_python_code = \
1068         $(dist_sbin_SCRIPTS) \
1069         $(python_scripts) \
1070         $(pkglib_python_scripts) \
1071         $(nodist_pkglib_python_scripts) \
1072         $(nodist_tools_python_scripts) \
1073         $(python_tests) \
1074         $(pkgpython_PYTHON) \
1075         $(client_PYTHON) \
1076         $(hypervisor_PYTHON) \
1077         $(rapi_PYTHON) \
1078         $(server_PYTHON) \
1079         $(pytools_PYTHON) \
1080         $(http_PYTHON) \
1081         $(confd_PYTHON) \
1082         $(masterd_PYTHON) \
1083         $(impexpd_PYTHON) \
1084         $(utils_PYTHON) \
1085         $(watcher_PYTHON) \
1086         $(noinst_PYTHON) \
1087         $(qa_scripts)
1088
1089 srclink_files = \
1090         man/footer.rst \
1091         test/check-cert-expired_unittest.bash \
1092         test/daemon-util_unittest.bash \
1093         test/ganeti-cleaner_unittest.bash \
1094         test/import-export_unittest.bash \
1095         test/cli-test.bash \
1096         test/bash_completion.bash \
1097         htest/offline-test.sh \
1098         htest/cli-tests-defs.sh \
1099         $(all_python_code) \
1100         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1101
1102 check_python_code = \
1103         $(BUILD_BASH_COMPLETION) \
1104         $(CHECK_IMPORTS) \
1105         $(CHECK_HEADER) \
1106         $(DOCPP) \
1107         $(all_python_code)
1108
1109 lint_python_code = \
1110         ganeti \
1111         ganeti/http/server.py \
1112         $(dist_sbin_SCRIPTS) \
1113         $(python_scripts) \
1114         $(pkglib_python_scripts) \
1115         $(BUILD_BASH_COMPLETION) \
1116         $(CHECK_IMPORTS) \
1117         $(CHECK_HEADER) \
1118         $(DOCPP) \
1119         $(PYTHON_BOOTSTRAP)
1120
1121 standalone_python_modules = \
1122         lib/rapi/client.py \
1123         tools/ganeti-listrunner
1124
1125 pep8_python_code = \
1126         ganeti \
1127         ganeti/http/server.py \
1128         $(dist_sbin_SCRIPTS) \
1129         $(python_scripts) \
1130         $(pkglib_python_scripts) \
1131         $(BUILD_BASH_COMPLETION) \
1132         $(CHECK_HEADER) \
1133         $(DOCPP) \
1134         $(PYTHON_BOOTSTRAP) \
1135         qa
1136
1137 test/daemon-util_unittest.bash: daemons/daemon-util
1138
1139 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1140
1141 test/bash_completion.bash: doc/examples/bash_completion-debug
1142
1143 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1144         sed -f $(REPLACE_VARS_SED) < $< > $@
1145         chmod +x $@
1146
1147 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1148         sed -f $(REPLACE_VARS_SED) < $< > $@
1149         chmod +x $@
1150
1151 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1152         sed -f $(REPLACE_VARS_SED) < $< > $@
1153         chmod +x $@
1154
1155 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1156         sed -f $(REPLACE_VARS_SED) < $< > $@
1157
1158 doc/examples/bash_completion: BC_ARGS = --compact
1159 doc/examples/bash_completion-debug: BC_ARGS =
1160
1161 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1162         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1163         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1164         daemons/ganeti-cleaner \
1165         $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1166         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1167           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1168
1169 doc/%.png: doc/%.dot
1170         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1171         $(DOT) -Tpng -o $@ $<
1172
1173 man/footer.man: man/footer.rst
1174         @test -n "$(PANDOC)" || \
1175           { echo 'pandoc' not found during configure; exit 1; }
1176         $(PANDOC) -f rst -t man -o $@ $<
1177
1178 man/footer.html: man/footer.rst
1179         @test -n "$(PANDOC)" || \
1180           { echo 'pandoc' not found during configure; exit 1; }
1181         $(PANDOC) -f rst -t html -o $@ $<
1182
1183 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1184         lib/build/shell_example_lexer.py \
1185         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1186         @echo "Checking $< for hardcoded paths..."
1187         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1188           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1189           exit 1; \
1190         fi
1191         set -e ; \
1192         trap 'echo auto-removing $@; rm $@' EXIT; \
1193         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1194         trap - EXIT
1195
1196 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1197         @test -n "$(PANDOC)" || \
1198           { echo 'pandoc' not found during configure; exit 1; }
1199         set -o pipefail ; \
1200         trap 'echo auto-removing $@; rm $@' EXIT; \
1201         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1202           sed -e 's/\\@/@/g' > $@; \
1203         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1204         $(CHECK_MAN_DASHES) $@; \
1205         trap - EXIT
1206
1207
1208 man/%.html.in: man/%.gen man/footer.html
1209         @test -n "$(PANDOC)" || \
1210           { echo 'pandoc' not found during configure; exit 1; }
1211         set -o pipefail ; \
1212         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1213           sed -e 's/\\@/@/g' > $@
1214
1215 man/%: man/%.in  $(REPLACE_VARS_SED)
1216         sed -f $(REPLACE_VARS_SED) < $< > $@
1217
1218 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1219         sed -f $(REPLACE_VARS_SED) < $< > $@
1220
1221 vcs-version:
1222         if test -d .git; then \
1223           git describe > $@; \
1224         elif test ! -f $@ ; then \
1225           echo "Cannot auto-generate $@ file"; exit 1; \
1226         fi
1227
1228 .PHONY: clean-vcs-version
1229 clean-vcs-version:
1230         rm -f vcs-version
1231
1232 .PHONY: regen-vcs-version
1233 regen-vcs-version:
1234         @set -e; \
1235         cd $(srcdir); \
1236         if test -d .git; then \
1237           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1238           git describe > $$T; \
1239           if ! cmp --quiet $$T vcs-version; then \
1240             mv $$T vcs-version; \
1241           fi; \
1242         fi
1243
1244 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1245         vcs-version $(built_base_sources)
1246         set -e; \
1247         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1248         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1249
1250 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1251         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1252         lib/jstore.py \
1253         $(CONVERT_CONSTANTS) $(built_base_sources) \
1254         | lib/_vcsversion.py
1255         set -e; \
1256         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1257
1258 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1259         $(built_base_sources)
1260         set -e; \
1261         { cat $< ; \
1262           echo ; \
1263           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1264             echo "import $$name ()" ; \
1265           done ; \
1266         } > $@
1267
1268 lib/_autoconf.py: Makefile | stamp-directories
1269         set -e; \
1270         { echo '# This file is automatically generated, do not edit!'; \
1271           echo '#'; \
1272           echo ''; \
1273           echo '"""Build-time configuration for Ganeti.'; \
1274           echo '';\
1275           echo 'This file is autogenerated by the build process.'; \
1276           echo 'For any changes you need to re-run ./configure (and'; \
1277           echo 'not edit by hand).'; \
1278           echo ''; \
1279           echo '"""'; \
1280           echo ''; \
1281           echo '# pylint: disable=C0301,C0324'; \
1282           echo '# because this is autogenerated, we do not want'; \
1283           echo '# style warnings' ; \
1284           echo ''; \
1285           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1286           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1287           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1288           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1289           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1290           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1291           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1292           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1293           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1294           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1295           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1296           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1297           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1298           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1299           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1300           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1301           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1302           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1303           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1304           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1305           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1306           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1307           echo "KVM_PATH = '$(KVM_PATH)'"; \
1308           echo "IP_PATH = '$(IP_PATH)'"; \
1309           echo "SOCAT_PATH = '$(SOCAT)'"; \
1310           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1311           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1312           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1313           echo "TOOLSDIR = '$(toolsdir)'"; \
1314           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1315           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1316           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1317           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1318           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1319           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1320           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1321           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1322           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1323           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1324           echo "RAPI_USER = '$(RAPI_USER)'"; \
1325           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1326           echo "CONFD_USER = '$(CONFD_USER)'"; \
1327           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1328           echo "NODED_USER = '$(NODED_USER)'"; \
1329           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1330           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1331           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1332           echo "HTOOLS = True"; \
1333           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1334           echo "XEN_CMD = '$(XEN_CMD)'"; \
1335           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1336           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1337           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1338         } > $@
1339
1340 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1341         set -e; \
1342         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1343         { echo '# This file is automatically generated, do not edit!'; \
1344           echo '#'; \
1345           echo ''; \
1346           echo '"""Build-time VCS version number for Ganeti.'; \
1347           echo '';\
1348           echo 'This file is autogenerated by the build process.'; \
1349           echo 'For any changes you need to re-run ./configure (and'; \
1350           echo 'not edit by hand).'; \
1351           echo ''; \
1352           echo '"""'; \
1353           echo ''; \
1354           echo '# pylint: disable=C0301,C0324'; \
1355           echo '# because this is autogenerated, we do not want'; \
1356           echo '# style warnings' ; \
1357           echo ''; \
1358           echo "VCS_VERSION = '$$VCSVER'"; \
1359         } > $@
1360
1361 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1362         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1363
1364 $(SHELL_ENV_INIT): Makefile stamp-directories
1365         set -e; \
1366         { echo '# Allow overriding for tests'; \
1367           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1368           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1369           echo; \
1370           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1371           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1372           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1373           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1374           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1375         } > $@
1376
1377 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1378         set -e; \
1379         { echo 's#@PREFIX@#$(prefix)#g'; \
1380           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1381           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1382           echo 's#@BINDIR@#$(bindir)#g'; \
1383           echo 's#@SBINDIR@#$(sbindir)#g'; \
1384           echo 's#@LIBDIR@#$(libdir)#g'; \
1385           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1386           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1387           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1388           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1389           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1390           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1391           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1392           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1393           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1394           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1395           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1396           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1397           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1398           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1399           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1400           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1401           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1402           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1403           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1404           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1405           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1406           echo; \
1407           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1408           echo '  r $(SHELL_ENV_INIT)'; \
1409           echo '  d'; \
1410           echo '}'; \
1411         } > $@
1412
1413 # Using deferred evaluation
1414 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1415 daemons/ganeti-watcher: MODULE = ganeti.watcher
1416 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1417 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1418 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1419 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1420 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1421 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1422
1423 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1424         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1425         set -e; \
1426         { echo '#!/usr/bin/python'; \
1427           echo '# This file is automatically generated, do not edit!'; \
1428           echo "# Edit $(MODULE) instead."; \
1429           echo; \
1430           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1431           echo; \
1432           echo '# pylint: disable=C0103'; \
1433           echo '# C0103: Invalid name'; \
1434           echo; \
1435           echo 'import sys'; \
1436           echo 'import $(MODULE) as main'; \
1437           echo; \
1438           echo '# Temporarily alias commands until bash completion'; \
1439           echo '# generator is changed'; \
1440           echo 'if hasattr(main, "commands"):'; \
1441           echo '  commands = main.commands # pylint: disable=E1101'; \
1442           echo 'if hasattr(main, "aliases"):'; \
1443           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1444           echo; \
1445           echo 'if __name__ == "__main__":'; \
1446           echo '  sys.exit(main.Main())'; \
1447         } > $@
1448         chmod u+x $@
1449
1450 $(HS_BUILT_TEST_HELPERS): Makefile
1451         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1452         set -e; \
1453         { echo '#!/bin/sh'; \
1454           echo '# This file is automatically generated, do not edit!'; \
1455           echo "# Edit Makefile.am instead."; \
1456           echo; \
1457           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1458         } > $@
1459         chmod u+x $@
1460
1461 stamp-directories: Makefile
1462         $(MAKE) $(AM_MAKEFLAGS) ganeti
1463         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1464         touch $@
1465
1466 # We need to create symlinks because "make distcheck" will not install Python
1467 # files when building.
1468 stamp-srclinks: Makefile | stamp-directories
1469         set -e; \
1470         for i in $(srclink_files); do \
1471           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1472             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1473           fi; \
1474         done
1475         touch $@
1476
1477 .PHONY: ganeti
1478 ganeti:
1479         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1480
1481 .PHONY: check-dirs
1482 check-dirs: $(GENERATED_FILES)
1483         @set -e; \
1484         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1485           error=; \
1486           while read dir; do \
1487             case "$$dir" in \
1488               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1489               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1490             esac; \
1491           done; \
1492           for dir in $(DIRS); do \
1493             if ! test -d "$$dir"; then \
1494               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1495               error=1; \
1496             fi \
1497           done; \
1498           test -z "$$error"; \
1499         }
1500
1501 .PHONY: check-local
1502 check-local: check-dirs $(GENERATED_FILES)
1503         $(CHECK_PYTHON_CODE) $(check_python_code)
1504         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1505         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1506         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1507         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1508         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1509         error= ; \
1510         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1511           echo "Incorrect version in README, expected $$expver" >&2; \
1512           error=1; \
1513         fi; \
1514         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1515             doc/security.rst; do \
1516           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1517             "Documents Ganeti version $$expver"; then \
1518             echo "Incorrect version in $$file, expected $$expver" >&2; \
1519             error=1; \
1520           fi; \
1521         done; \
1522         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1523           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1524           error=1; \
1525         fi; \
1526         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1527           ".. Last updated for Ganeti $$expver"; then \
1528           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1529           error=1; \
1530         fi; \
1531         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1532           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1533             echo "Longest line in $$file is longer than 80 characters" >&2; \
1534             error=1; \
1535           fi; \
1536         done; \
1537         test -z "$$error"
1538
1539 .PHONY: hs-check
1540 hs-check: htest/test htest/hpc-htools htest/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1541         @rm -f *.tix
1542         ./htest/test
1543         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1544
1545 # E111: indentation is not a multiple of four
1546 # E121: continuation line indentation is not a multiple of four
1547 #       (since our indent level is not 4)
1548 # E125: continuation line does not distinguish itself from next logical line
1549 #       (since our indent level is not 4)
1550 # E127: continuation line over-indented for visual indent
1551 #       (since our indent level is not 4)
1552 # note: do NOT add E128 here; it's a valid style error in most cases!
1553 # I've seen real errors, but also some cases were we indent wrongly
1554 # due to line length; try to rework the cases where it is triggered,
1555 # instead of silencing it
1556 # E261: at least two spaces before inline comment
1557 # E501: line too long (80 characters)
1558 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1559
1560 # For excluding pep8 expects filenames only, not whole paths
1561 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1562
1563 LINT_TARGETS = pylint pylint-qa
1564 if HAS_PEP8
1565 LINT_TARGETS += pep8
1566 endif
1567 if HAS_HLINT
1568 LINT_TARGETS += hlint
1569 endif
1570
1571 .PHONY: lint
1572 lint: $(LINT_TARGETS)
1573
1574 .PHONY: pylint
1575 pylint: $(GENERATED_FILES)
1576         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1577         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1578
1579 .PHONY: pylint-qa
1580 pylint-qa: $(GENERATED_FILES)
1581         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1582         cd $(top_srcdir)/qa && \
1583           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1584           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1585
1586 .PHONY: pep8
1587 pep8: $(GENERATED_FILES)
1588         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1589         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1590           --repeat $(pep8_python_code)
1591
1592 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1593 HLINT_EXCLUDES = htools/Ganeti/THH.hs htest/hpc-htools.hs
1594 .PHONY: hlint
1595 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1596         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1597         if tty -s; then C="-c"; else C=""; fi; \
1598         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1599           --ignore "Use first" \
1600           --ignore "Use &&&" \
1601           --ignore "Use void" \
1602           --ignore "Reduce duplication" \
1603           --hint htools/lint-hints \
1604           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1605
1606 # a dist hook rule for updating the vcs-version file; this is
1607 # hardcoded due to where it needs to build the file...
1608 dist-hook:
1609         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1610         rm -f $(top_distdir)/vcs-version
1611         cp -p $(srcdir)/vcs-version $(top_distdir)
1612
1613 # a distcheck hook rule for catching revision control directories
1614 distcheck-hook:
1615         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1616           echo "Found revision control files in final archive." 1>&2; \
1617           exit 1; \
1618         fi
1619         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1620           echo "Found Python byte code in final archive." 1>&2; \
1621           exit 1; \
1622         fi
1623         if find $(top_distdir) -name '*~' | grep .; then \
1624           echo "Found backup files in final archive." 1>&2; \
1625           exit 1; \
1626         fi
1627 # Empty files or directories should not be distributed. They can cause
1628 # unnecessary warnings for packagers. Directories used by automake during
1629 # distcheck must be excluded.
1630         if find $(top_distdir) -empty -and -not \( \
1631             -path $(top_distdir)/_build -or \
1632             -path $(top_distdir)/_inst \) | grep .; then \
1633           echo "Found empty files or directories in final archive." 1>&2; \
1634           exit 1; \
1635         fi
1636         if test -n "$(BUILD_RELEASE)" && \
1637            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1638            echo "Found unreleased version in NEWS." >&2; \
1639            exit 1; \
1640         fi
1641
1642 # When building a release, stricter checks should be used
1643 distcheck-release dist-release: export BUILD_RELEASE = 1
1644 distcheck-release: distcheck
1645
1646 distrebuildcheck: dist
1647         set -e; \
1648         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1649         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1650         cd $$builddir; \
1651         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1652         cd $(distdir); \
1653         ./configure; \
1654         $(MAKE) maintainer-clean; \
1655         cp $(abs_srcdir)/vcs-version .; \
1656         ./configure; \
1657         $(MAKE) $(AM_MAKEFLAGS)
1658
1659 dist-release: dist
1660         set -e; \
1661         for i in $(DIST_ARCHIVES); do \
1662           echo -n "Checking $$i ... "; \
1663           autotools/check-tar < $$i; \
1664           echo OK; \
1665         done
1666
1667 install-exec-local:
1668         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1669           "$(DESTDIR)${localstatedir}/log/ganeti" \
1670           "$(DESTDIR)${localstatedir}/run/ganeti"
1671
1672 .PHONY: apidoc
1673 if WANT_HTOOLSAPIDOC
1674 apidoc: py-apidoc hs-apidoc
1675 else
1676 apidoc: py-apidoc
1677 endif
1678
1679 .PHONY: py-apidoc
1680 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1681         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1682         $(RUN_IN_TEMPDIR) epydoc -v \
1683           --conf $(CURDIR)/epydoc.conf \
1684           --output $(CURDIR)/$(APIDOC_PY_DIR)
1685
1686 .PHONY: hs-apidoc
1687 hs-apidoc: $(HS_BUILT_SRCS)
1688         @test -n "$(HSCOLOUR)" || \
1689             { echo 'HsColour' not found during configure; exit 1; }
1690         @test -n "$(HADDOCK)" || \
1691             { echo 'haddock' not found during configure; exit 1; }
1692         rm -rf $(APIDOC_HS_DIR)/*
1693         for i in $(ALL_APIDOC_HS_DIRS); do \
1694           @mkdir_p@ $$i; \
1695         done
1696         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1697         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1698         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1699         set -e ; \
1700         cd htools; \
1701         if [ "$(HTOOLS_NOCURL)" ]; \
1702         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1703         else OPTGHC=""; \
1704         fi; \
1705         if [ "$(HTOOLS_PARALLEL3)" ]; \
1706         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1707         fi; \
1708         if [ "$(HTOOLS_REGEX_PCRE)" ]; \
1709         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
1710         fi; \
1711         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1712         for file in $$RELSRCS; do \
1713           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1714           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1715         done ; \
1716         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1717           -t ganeti -p haddock-prologue \
1718           --source-module="%{MODULE/.//}.html" \
1719           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1720           $$OPTGHC \
1721           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1722
1723 .PHONY: TAGS
1724 TAGS: $(GENERATED_FILES)
1725         rm -f TAGS
1726         $(GHC) -e ":etags" -v0 \
1727           $(filter-out -O -Werror,$(HFLAGS)) \
1728           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
1729           $(HS_LIBTEST_SRCS)
1730         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1731           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1732           -path './qa/*.py' | \
1733           etags -l python -a -
1734
1735 .PHONY: coverage
1736 if WANT_HTOOLS
1737 coverage: py-coverage hs-coverage
1738 else
1739 coverage: py-coverage
1740 endif
1741
1742 .PHONY: py-coverage
1743 py-coverage: $(GENERATED_FILES) $(python_tests)
1744         @test -n "$(PYCOVERAGE)" || \
1745             { echo 'python-coverage' not found during configure; exit 1; }
1746         set -e; \
1747         COVERAGE=$(PYCOVERAGE) \
1748         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1749         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1750         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1751         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1752         $(python_tests)
1753
1754 .PHONY: hs-coverage
1755 hs-coverage: $(haskell_tests) htest/hpc-htools htest/hpc-mon-collector
1756         rm -f *.tix
1757         $(MAKE) $(AM_MAKEFLAGS) hs-check
1758         @mkdir_p@ $(COVERAGE_HS_DIR)
1759         hpc sum --union $(HPCEXCL) \
1760           test.tix hpc-htools.tix hpc-mon-collector.tix > coverage-htools.tix
1761         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1762         hpc report coverage-htools.tix
1763         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1764
1765 # Special "kind-of-QA" target for htools, needs special setup (all
1766 # tools compiled with -fhpc)
1767 .PHONY: live-test
1768 live-test: all
1769         set -e ; \
1770         cd htools; \
1771         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1772         rm -f *.tix *.mix; \
1773         ./live-test.sh; \
1774         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1775           --output=live-test.tix ; \
1776         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1777         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1778           --srcdir=.. $(HPCEXCL) ; \
1779         hpc report --srcdir=.. live-test $(HPCEXCL)
1780
1781 commit-check: distcheck lint apidoc
1782
1783 .PHONY: gitignore-check
1784 gitignore-check:
1785         @if [ -n "`git status --short`" ]; then \
1786           echo "Git status is not clean!" 1>&2 ; \
1787           git status --short; \
1788           exit 1; \
1789         fi
1790
1791 # Target that builds all binaries (including those that are not
1792 # rebuilt except when running the tests)
1793 .PHONY: really-all
1794 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1795
1796 # we don't need the ancient implicit rules:
1797 %: %,v
1798 %: RCS/%,v
1799 %: RCS/%
1800 %: s.%
1801 %: SCCS/s.%
1802
1803 -include ./Makefile.local
1804
1805 # vim: set noet :